﻿/*****************************************************************
 * Jackson Fields
 * AssetFactory.cs
 * ***************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    /// <summary>
    /// Create Assets of type T
    /// </summary>
    /// <typeparam name="T">asset Type</typeparam>
    public class AssetFactory<T>
    {
        protected Game game;
        public AssetFactory(Game game)
        {
            this.game = game;
        }

        /// <summary>
        /// Load an art asset into memory
        /// </summary>
        /// <typeparam name="T">type of asset to load</typeparam>
        /// <param name="name">address inside Content Project</param>
        /// <param name="content">content manager from game to load asset</param>
        /// <returns>the loaded asset</returns>
        public T LoadAsset(String name)
        {
            return game.Content.Load<T>(name);
        }

    }
}
