﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Engine;

namespace Engine
{
    public class Circle
    {
        PixelTexture pix;

        public float alpha = 1;

        private float radius;
        public float Radius
        {
            get { return radius; }
            set { radius = value; }
        }

        private Vector2 origin;
        public Vector2 Origin
        {
            get { return origin; }
            set { origin = value; }
        }

        public Color Color { get; set; }

        public Circle(Game game, Vector2 origin, float radius)
        {
            Origin = origin;
            Radius = radius;
            pix = new PixelTexture(game, Color.AliceBlue);
            this.Color = Color.White;
        }

        public Circle(Game game, Vector2 origin, float radius, Color color)
        {
            Origin = origin;
            Radius = radius;
            pix = new PixelTexture(game, Color.AliceBlue);
            this.Color = color;
        }

        /// <summary>
        /// Draws a circle
        /// </summary>
        /// <param name="sb"></param>
        /// <param name="gameTime"></param>
        public void Draw(SpriteBatch sb, GameTime gameTime)
        {
            // Draw circle here
            int numPixels = (int)(5 * Radius);
            float increment = 6.28f / (float)numPixels;
            float angle = 0.0f;
            Vector2 pos;
            for (int i = 0; i < numPixels; i++)
            {
                pos = new Vector2((float)(Radius * Math.Cos(angle)), (float)(Radius * Math.Sin(angle)));
                pos += Origin;
                sb.Draw(pix.Texture, new Rectangle((int)pos.X - circleWidth, (int)pos.Y - circleWidth, circleWidth * 2, circleWidth * 2), Color.AliceBlue);
                angle += increment;
            }

        }

        public void Draw(SpriteBatch sb, GameTime gameTime, float alpha)
        {
            this.alpha = alpha;
            // Draw circle here
            int numPixels = (int)(5 * Radius);
            float increment = 6.28f / (float)numPixels;
            float angle = 0.0f;
            Vector2 pos;
            for (int i = 0; i < numPixels; i++)
            {
                pos = new Vector2((float)(Radius * Math.Cos(angle)), (float)(Radius * Math.Sin(angle)));
                pos += Origin;
                sb.Draw(pix.Texture, new Rectangle((int)pos.X - circleWidth, (int)pos.Y - circleWidth, circleWidth * 2, circleWidth * 2), Color.AliceBlue * alpha);
                angle += increment;
            }

        }
        int circleWidth = 2;
    }
}
