﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Engine
{
    public partial class Line
    {
        private Vector2 p1;
        public Vector2 P1
        {
            get { return p1; }
            set { p1 = value; }
        }

        private Vector2 p2;
        public Vector2 P2
        {
            get { return p2; }
            set { p2 = value; }
        }

        public Line(Vector2 p1, Vector2 p2)
        {
            P1 = p1;
            P2 = p2;
        }
        public Line(float x1, float y1, float x2, float y2)
        {
            P1 = new Vector2(x1, x2);
            P2 = new Vector2(x2, y2);
        }

        /// <summary>
        /// Draws a line
        /// </summary>
        /// <param name="sb"></param>
        /// <param name="gameTime"></param>
        public void Draw(Game game, SpriteBatch sb, GameTime gameTime)
        {

            PixelTexture pix = new PixelTexture(game, Color.Red);
            // Draw circle here
            int numPixels = 20;
            Vector2 incV = (P2 -P1); 
            float incL = incV.Length() / (float)numPixels;
            incV.Normalize();
            Vector2 pos;
            for (int i = 0; i < numPixels; i++)
            {
                pos = P1 + incV * (incL * i);
                sb.Draw(pix.Texture, pos, Color.White);
            }
            pix = new PixelTexture(game, Color.Yellow);
            sb.Draw(pix.Texture, new Rectangle((int)P1.X - 1, (int)P1.Y - 1, 3, 3), Color.White);
            sb.Draw(pix.Texture, new Rectangle((int)P2.X - 1, (int)P2.Y - 1, 3, 3), Color.White);

        }
    }
}
