﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    public class FadeLayout
    {
        Color startColor;
        Color fadeColor;
        float fadeTime;
        float startTime;
        float elapsedTime = 0;
        PixelTexture pix;
        Game game;
        float alpha = 0;

        public Boolean hasFaded = false;

        public FadeLayout(Game game, Color startColor, Color fadeColor, float startTime, float fadeTime)
        {
            this.game = game;
            this.startColor = startColor;
            this.fadeColor = fadeColor;
            this.startTime = startTime;
            this.fadeTime = fadeTime;

            pix = new PixelTexture(game, Color.White);
        }

        public void Update(GameTime gameTime)
        {
            elapsedTime += gameTime.ElapsedGameTime.Milliseconds;

            if (elapsedTime > startTime)
            {
                if (elapsedTime <= startTime + fadeTime)
                {
                    alpha = (elapsedTime - startTime) / fadeTime;
                }

                if (elapsedTime > startTime + fadeTime)
                {
                    hasFaded = true;
                }
            }
        }

        public void Draw(SpriteBatch sb, GameTime gameTime)
        {
            sb.Draw(pix.Texture,
                new Rectangle(0, 0, game.GraphicsDevice.Viewport.Width, game.GraphicsDevice.Viewport.Height),
                Color.Lerp(startColor, fadeColor, alpha));
        }
    }
}
