﻿/*****************************************************************
 * Jackson Fields
 * Layout.cs
 * ***************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    /// <summary>
    /// base layout class - what is updated and drawn
    /// </summary>
    public abstract class Layout
    {
        protected Game game;

        public Layout(Game game)
        {
            this.game = game;
        }

        public abstract void Initialize();
        public abstract void Update(GameTime gameTime);
        public abstract void Draw(SpriteBatch sb, GameTime gameTime);
    }
}
