﻿/*****************************************************************
 * Jackson Fields
 * PauseLayout.cs
 * ***************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    /// <summary>
    /// pause the game
    /// </summary>
    public class PauseLayout : Layout
    {
        Texture2D backGround;
        String pauseText = "Press 'p' to Resume";

        public PauseLayout(Game game)
            : base(game)
        {
            backGround = new PixelTexture(game, new Color(0, 0, 0, 0.5f)).Texture;
        }

        public override void Update(GameTime gameTime)
        {
            if (((EngineGame)game).input.Click(Keys.P))
            {
                ((EngineGame)game).currentLayout = ((EngineGame)game).getGameLayout();
            }
        }

        public override void Draw(SpriteBatch sb, GameTime gameTime)
        {
            ((EngineGame)game).getGameLayout().Draw(sb, gameTime);

            //game distorts sb, start a new one
            sb.End();
            sb.Begin();

            sb.Draw(backGround,
                new Rectangle(0, 0, game.GraphicsDevice.Viewport.Width, game.GraphicsDevice.Viewport.Height),
                Color.White);

            SpriteFontHelper.DrawCenteredText(sb, ((EngineGame)game).font, "Paused",
                new Vector2(game.GraphicsDevice.Viewport.Width / 2,
                    game.GraphicsDevice.Viewport.Height / 2), Color.White);

            SpriteFontHelper.DrawCenteredText(sb, ((EngineGame)game).font, pauseText,
                new Vector2(game.GraphicsDevice.Viewport.Width / 2,
                    game.GraphicsDevice.Viewport.Height / 2 + ((EngineGame)game).font.MeasureString(pauseText).Y), 
                    Color.White);
        }
    }
}
