﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    public static class MouseRay
    {
        public static Ray GetMouseRay(Game game, Vector2 mousePos, FPSCamera camera)
        {
            Vector3 nearSource = new Vector3(mousePos.X, mousePos.Y, 0);
            Vector3 farSource = new Vector3(mousePos.X, mousePos.Y, 1);

            Vector3 nearPoint = game.GraphicsDevice.Viewport.Unproject(nearSource,
                camera.Projection, camera.View, Matrix.Identity);
            Vector3 farPoint = game.GraphicsDevice.Viewport.Unproject(farSource,
                camera.Projection, camera.View, Matrix.Identity);

            Vector3 dir = farPoint - nearPoint;
            dir.Normalize();

            return new Ray(nearPoint, dir);
        }

        public static Vector3 GetPointAlongSelectionRay(Game game, Vector2 mousePos, FPSCamera camera, float distance)
        {
            Ray selectionRay = GetMouseRay(game, mousePos, camera);

            return selectionRay.Position + selectionRay.Direction * distance;
        }
    }
}
