﻿/*****************************************************************
 * Jackson Fields
 * PixelTexture.cs
 * ***************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    /// <summary>
    /// Creates a 1x1 pixel texture
    /// </summary>
    public class PixelTexture
    {
        public Texture2D Texture { get { return texture; } }
        Texture2D texture;
        Color[] pixel = new Color[1];

        public PixelTexture(Game game)
        {
            pixel[0] = Color.White;
            texture = new Texture2D(game.GraphicsDevice, 1, 1, false, SurfaceFormat.Color);
            texture.SetData(pixel);
        }

        public PixelTexture(Game game, Color color)
        {
            pixel[0] = color;
            texture = new Texture2D(game.GraphicsDevice, 1, 1, false, SurfaceFormat.Color);
            texture.SetData(pixel);
        }
    }
}
