﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace kinectApp
{
    public partial class BoundForm : Form
    {
        Game1 game;

        public BoundForm(Game1 game)
        {
            this.game = game;
            InitializeComponent();
        }

        private void applyButton_Click(object sender, EventArgs e)
        {
            AssignValueFromString(this.minXTextBox.Text, ref game.kinectManager.minX);
            AssignValueFromString(this.maxXTextBox.Text, ref game.kinectManager.maxX);
            AssignValueFromString(this.minYTextBox.Text, ref game.kinectManager.minY);
            AssignValueFromString(this.maxYTextBox.Text, ref game.kinectManager.maxY);
            AssignValueFromString(this.minZTextBox.Text, ref game.kinectManager.minZ);
            AssignValueFromString(this.maxZTextBox.Text, ref game.kinectManager.maxZ);
        }

        private void AssignValueFromString(string value, ref float container)
        {
            if (value != string.Empty)
            {
                container = (float)Convert.ToDouble(value);
            }
        }

        private void decreaseStringAndAssign(ref TextBox textBox, ref float container)
        {
            float val = 0;
            try
            {
                val = (float)(Convert.ToDouble(textBox.Text));
            }
            catch { }
            val -= 0.1f;

            textBox.Text = val.ToString();

            AssignValueFromString(textBox.Text, ref container);
        }

        private void increaseStringAndAssign(ref TextBox textBox, ref float container)
        {
            float val = 0;
            try
            {
                val = (float)(Convert.ToDouble(textBox.Text));
            }
            catch { }
            val += 0.1f;

            textBox.Text = val.ToString();

            AssignValueFromString(textBox.Text, ref container);
        }

        private void minXMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.minXTextBox, ref game.kinectManager.minX);
        }

        private void maxXMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.maxXTextBox, ref game.kinectManager.maxX);
        }

        private void minYMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.minYTextBox, ref game.kinectManager.minY);
        }

        private void maxYMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.maxYTextBox, ref game.kinectManager.maxY);

        }

        private void minZMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.minZTextBox, ref game.kinectManager.minZ);
        }

        private void maxZMinusButton_Click(object sender, EventArgs e)
        {
            decreaseStringAndAssign(ref this.maxZTextBox, ref game.kinectManager.maxZ);
        }

        private void minXPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.minXTextBox, ref game.kinectManager.minX);
        }

        private void maxXPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.maxXTextBox, ref game.kinectManager.maxX);
        }

        private void minYPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.minYTextBox, ref game.kinectManager.minY);
        }

        private void maxYPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.maxYTextBox, ref game.kinectManager.maxY);
        }

        private void minZPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.minZTextBox, ref game.kinectManager.minZ);
        }

        private void maxZPlusButton_Click(object sender, EventArgs e)
        {
            increaseStringAndAssign(ref this.maxZTextBox, ref game.kinectManager.maxZ);
        }
    }
}
