﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Engine;

namespace kinectApp
{
    //TODO: read from XML
    public interface TreeRules
    {
        int TrunkAngle();
        float LeafTaper();
        int NumIterations();
        int SubsequentAngle();
        int NumTrunkBranchesOffSplit();
        int NumBranchesOffSplit();
        float NumSegmentsInBranch();
        float SegmentOffset();
        //int NumFinalBranches();
        float LengthReductionFactor();
        float branchSphereConnectorScaleFactor();
        float BranchStartWidth();
        float TrunkStartWidth();
        float TwigStartWidth();
        float MinBranchWidth();
        float TaperPercent();
        float TrunkTaperPercent();
        int NumPointsOnLobe();
        int NumLeafPointsOnLobe();
        float Angle();
        int BranchIterations();
        int Tesselation();

        float MaxTrunkHeightPercent();

        List<LeafLobe> CreateBranchControlPoints(List<LeafLobe> leafLobes);
        List<LeafLobe> CreateLeafControlPoints(List<LeafLobe> leafLobes);

        void ConnectBranchesToLeafLobes();

        void CreateLeaves(Game1 game, TreeBranch branch);
        Texture2D LeafTexture();
    }
}
